Unit ADG1C_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, AFG1C_p;

procedure ADG1C(var A :Array of Complex; var D1 :Complex;
                var D2 :Integer; var S :Array of Integer;
                N :Integer);

implementation

procedure ADG1C(var A :Array of Complex; var D1 :Complex;
                var D2 :Integer; var S :Array of Integer;
                N :Integer);
var
I :Integer;
label
_1,_2,_3,_4,_5,_6;
begin
AFG1C(A,S,N);
S[N-1] := N;
D1 := Cmplx(1.0,0.0);
D2 := 0;
for I:=1 to N do
 begin
  D1 := MulC(D1,A[(I-1)+(I-1)*N]);
  if ( Cabs(D1) = 0 ) 
   then goto _5;
_1:
  if ( Cabs(D1) < 1.0 ) 
   then goto _2;
  D1 := MulC(D1,Cmplx(0.0625,0.0));
  D2 := D2+4;
  goto _1;
_2:
  if ( Cabs(D1) >= 0.0625 ) 
   then goto _3;
  D1 := MulC(D1,Cmplx(16.0,0.0));
  D2 := D2-4;
  goto _2;
_3:
 end;
for I:=1 to N do
 begin
  if ( S[I-1] <> I ) 
   then D1 := SubC(Cmplx(0.0,0.0),D1);
_4:
 end;
goto _6;
_5:
D1 := Cmplx(0.0,0.0);
D2 := 0;
_6:
end;

end.
