Unit AFG1C_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure AFG1C(var A :Array of Complex; var S :Array of Integer;
                N :Integer);

implementation

procedure AFG1C(var A :Array of Complex; var S :Array of Integer;
                N :Integer);
var
F,BG,I,J,L :Integer;
BJ,BN,TK :Real;
BX,PR :Complex;
const
ZERO :Real = 0.0;
label
_1,_2,_3,_4,_5,_6,_7;
begin
if ( N = 1 ) 
 then goto _7;
F := 0;
_1:
F := F+1;
BG := F;
BJ := ZERO;
for I:=F to N do
 begin
  BN := Cabs(A[(I-1)+(F-1)*N]);
  if ( BJ >= BN ) 
   then goto _2;
  BJ := BN;
  BG := I;
_2:
 end;
for J:=1 to N do
 begin
  BX := A[(BG-1)+(J-1)*N];
  A[(BG-1)+(J-1)*N] := A[(F-1)+(J-1)*N];
_3:
  A[(F-1)+(J-1)*N] := BX;
 end;
S[F-1] := BG;
L := F+1;
TK := Cabs(A[(F-1)+(F-1)*N]);
if ( TK = 0 ) 
 then goto _6;
PR := DivC(Cmplx(1.0,0.E0),A[(F-1)+(F-1)*N]);
for I:=L to N do
 begin
_4:
  A[(I-1)+(F-1)*N] := MulC(PR,A[(I-1)+(F-1)*N]);
 end;
for J:=L to N do
 begin
  for I:=L to N do
   begin
_5:
    A[(I-1)+(J-1)*N] := SubC(A[(I-1)+(J-1)*N],MulC(A[(F-1)+(J-1)*N],A[(I-1)+(F-1)*N]));
   end;
 end;
_6:
if ( L-N ) < 0
 then goto _1
 else if ( L-N ) > 0
       then goto _7
       else goto _7;
_7:
end;

end.
